One way I try to challenge myself when solving these problems: If I can't solve intitally and I am just stuck, come to NeetCode's videos and watch the intuition portion. If I feel like I have a good idea of what he's talking about, I will pause the video and attempt to solve again under a time limit. If I can't solve it again, I will come back to his vid and watch for the solution as well.
@RhoBustDevАй бұрын
appreciate it, its the same for me :)
@victortruong2538 Жыл бұрын
Oh I was waiting for you :) yes the problem is poorly worded I feel
@0brooo6 ай бұрын
THIS is a valid solution to this problem. I was looking at the solutions with the most upvotes, and their solution was to mathematically solve it by adding up all the longest increasing subarray and decreasing subarray, and then subtracting the lowest of the two from the totalCandy. I hate that leetcode solutions have become mathematically solutions rather than programming. Solutions for the CarFleet problem is a hashmap with the key being the product of a formula. Then returning all the unique keys. Like what is that, the solution should go through a process that imitates the problem. Now we’re seeing problems that are purely solved by inventing a formula for the specific issue. Rather than preparing you for problems you’ll face regularly
@HtotheG Жыл бұрын
I came up with the O(n^2) solution with a while loop of while(candyIncreasedThisLoop){ do a pass and add 1 if the rules arent followed for each } and I was proud of myself, but damn this code is not only neat is damn near beautiful 😢 Thank you for the great explanation as always you are a huge help in my career journey as a new grad at the moment. I can't thank you enough for your years of backlogs of coding solutions I am learning from right now. Keep up the amazing work!
@harshiv20059 ай бұрын
Same dude
@cody-wq7zc9 ай бұрын
same
@adamlin23018 ай бұрын
And this is how your boss think of giving salary to you
@HR-pz7ts8 ай бұрын
Thanks man you're so good that I never had to wait for you to code.
@VarunMittal-viralmutant2 ай бұрын
An alternate to the last step: if ratings[i] > ratings[i+1]: arr[i] = max(arr[i], arr[i+1]+1) That was more intuitive for me: if ratings[i] > ratings[i+1] and arr[i]
@JasonAhn-u5u Жыл бұрын
I only thought about iterating through left -> right..always amazing
@studimeyt5219 Жыл бұрын
same 🤧
@GuruPrasadShukla Жыл бұрын
very well explained! just like interview style!
@CognitiveAnkit10 ай бұрын
You are totally more than awesome You explained this concept in such an awesome manner I have no words for it
@dineshkumarkb1372 Жыл бұрын
Thanks for uploading this. I had requested for this in the comments in one of your videos.
@hannibalm090009 Жыл бұрын
Thanks a lot bro, I actually just solved it had to pause the video at the mid of the intuition because that was the missing part that I needed, went and solved it then got back.
@abdelrahmanashraf1510 Жыл бұрын
You mentioned that no extra memory is needed, yet your solution clearly allocated a new array to track the number of candies given. Doesn't that make the space complexity O(n)?
@NeetCodeIO Жыл бұрын
Yep, that's my bad. Space is O(n)
@abdelrahmanashraf1510 Жыл бұрын
@@NeetCodeIO Thanks for clarifying! appreciate your efforts and explanations 👍🏼
@socialbeing55917 ай бұрын
literally the best explaination
@iCodeStuff6910 ай бұрын
Quite much easier problem than lots of "easy" ones.
@schrodingerskatt222 Жыл бұрын
Amazing explanation !!!!. Greedy Questions are just mind blowing.
@AyushSharma-ux4fk Жыл бұрын
Yea, greedy hits you up as if you never know what has happened.
@joey_zhu7 ай бұрын
I derived my solution by going deep into the diffs array and trying to reduce it to other problems, my soln ended up going to 30+ lines so i was quite disappointed to go into the solutions and see that ppl had done it in like 10 lines
@CodeWithRVR Жыл бұрын
Wait is over guys 😅
@CodeSuccessChronicle6 ай бұрын
Best Explanation 👏🏻 Nice work great intution
@jaishriharivishnu5 ай бұрын
how you get so good at logic, damn nice and nice , best approach
@stith_pragya Жыл бұрын
Thank You So Much for this wonderful video...🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@deepakjain2489 ай бұрын
isn't it O(n) space solution as we are using extra array to store candies ?
@omdandade8245 Жыл бұрын
I missed that "welocme back" this morning...
@VidyaBhandary Жыл бұрын
Genius explanation... Wow
@krateskim4169 Жыл бұрын
was waiting for this
@elizabethr51618 ай бұрын
Best explanation ever
@aisteelmemesforaliving Жыл бұрын
Seems like this problem can be solved in one pass too, but I have a hard time understanding that lol. Would've been nice if you could explain the onepass method because I can understand your explanations only. Others take way too much time drawing, or do a poor job of explaining.
@aisteelmemesforaliving Жыл бұрын
@@Stay_away_from_my_swamp_waterno, apparently, you can use three variables up, down and peak and then do something which I don't understand to complete this in one pass and O(1) space complexity. It's the top solution on solutions page (by vanAmsen). I don't think I can post links here, the spam filter will probably go off.
@stefanopalmieri9201 Жыл бұрын
@@aisteelmemesforaliving I'm also looking for a better explanation of that algorithm. If I figure it out, I'll make a video.
@aisteelmemesforaliving Жыл бұрын
@@stefanopalmieri9201 please don't forget to reply to this if you actually do. Highly appreciated.